#include "AuthcodeUpdateDialog.h"
#include <QVBoxLayout>
#include <QLabel>
#include <QButtonGroup>
#include <QPushButton>
#include <DLabel.h>
#include <QVBoxLayout>
#include <DPasswordEdit.h>

AuthcodeUpdateDialog::AuthcodeUpdateDialog(const QString &addr, QWidget *parent) : DBaseDialog(parent)
{
    continuePrint = false;
    setWindowFlags(windowFlags() | Qt::WindowStaysOnTopHint);
    QWidget *authWidget = new QWidget;
    QVBoxLayout *authLayout = new QVBoxLayout();
    authLayout->setSpacing(0);
    authLayout->setMargin(10);
    DLabel *messageLabel = new DLabel(
                QString(tr("The authorization code of cloud print server (%1) has been updated")).arg(addr));
    messageLabel->setStyleSheet("font-size: 12px; color: white;");
    messageLabel->setWordWrap(true);
    authLayout->addSpacing(15);
    authLayout->addWidget(messageLabel);
    authEdit = new DPasswordEdit();
    authEdit->setFixedSize(310,24);
    authEdit->setPlaceholderText(tr("Please input a new authorization code"));
    authLayout->addSpacing(16);
    authLayout->addWidget(authEdit);
    authLayout->addSpacing(12);
    authWidget->setLayout(authLayout);
    authWidget->setFixedWidth(330);

    QString icon = ":/View/Resource/config-helper.svg";
    QStringList buttons, buttonTexts;
    buttons << "Cancel" << "Print";
    buttonTexts << tr("Cancel") << tr("Print");
    initUI(icon, authWidget, buttons, buttons);
    moveCenter();
    getButtonsGroup()->button(1)->setFocus();
    setButtonTexts(buttonTexts);

    setFixedWidth(444);

    connect(this, SIGNAL(buttonClicked(QString)),
            this, SLOT(handleButtonsClicked(QString)));
}

void AuthcodeUpdateDialog::handleButtonsClicked(QString key) {
    if (key == "Print") {
        continuePrint = true;
    }
}

void AuthcodeUpdateDialog::handleKeyEnter(){
    DBaseDialog::handleButtonsClicked(1);
}

QString AuthcodeUpdateDialog::getAuthcode() {
    return authEdit->text();
}

AuthcodeUpdateDialog::~AuthcodeUpdateDialog()
{

}

