#pragma once

#include <QObject>
#include "RPC/CloudPrint.h"

class ClientData;

QUrl formatAddress(QString rawAddr);
QUrl serverAddress(QUrl formatUrl);

class Printer: public cloudprint::Printer{
public:
    Printer(const cloudprint::Printer &p): cloudprint::Printer(p) {}

    ~Printer() throw() {}

    enum PrinterStatus {
        Idle        = 0x00000000,
        Processing  = 0x00000001,
        OutWork     = 0x00000002,
    };

    PrinterStatus localStatus();
    QString statusString();

    std::string StatusString;
    int         LocalStatus;
    bool        Added;
};

class CloudPrintRPCClient : public QObject
{
    Q_OBJECT
public:

    explicit CloudPrintRPCClient(const QString& addr, QObject *parent = 0);
    ~CloudPrintRPCClient();

    bool Connect();
    bool Verfiy(const cloudprint::Auth& auth);
    std::vector<Printer> ListPrinter(const cloudprint::Auth& auth);

private:
    ClientData *data;
};

