#pragma once

#include <QObject>
#include <QMap>
#include <QDateTime>

class ServerConfig {
public:
    QString     Authcode;
    QString     Address;
    QDateTime   LastUsed;
};

class Config {
public:
    Config();

    void load();
    void save();

    ServerConfig get(const QString& addr) {
        if (config.contains(addr))
            return config.value(addr);

        return ServerConfig();
    }

    void set(const QString& addr, const ServerConfig& sc) {
        config.insert(addr, sc);
    }

    ServerConfig lastUsed();

    QMap<QString, ServerConfig> config;
};
