QT += core gui widgets x11extras

TARGET = config-helper
TEMPLATE = lib
CONFIG += staticlib c++11

unix {
    target.path = /usr/lib
    INSTALLS += target
}

SOURCES += \
    View/ConfigDialog.cpp \
    Utils.cpp \
    View/PrinterWidget.cpp \
    RPC/CloudPrint_constants.cpp \
    RPC/CloudPrint_types.cpp \
    RPC/CloudPrint.cpp \
    RPC/Print_constants.cpp \
    RPC/Print_types.cpp \
    CloudPrintClient.cpp \
    CUPSClient.cpp \
    Config.cpp

HEADERS += \
    Utils.h \
    View/ConfigDialog.h \
    View/PrinterWidget.h \
    RPC/CloudPrint_constants.h \
    RPC/CloudPrint_types.h \
    RPC/CloudPrint.h \
    RPC/Print_constants.h \
    RPC/Print_types.h \
    CloudPrintClient.h \
    CUPSClient.h \
    Config.h

RESOURCES += \
    ConfigHelper.qrc

#################################################
#    Add Lib Ref
#################################################
LIBS += -lthrift -lcups -lxcb -lX11

win32:CONFIG(release, debug|release): LIBS += -L$$OUT_PWD/../DTK/Widget/release/ -ldwidget
else:win32:CONFIG(debug, debug|release): LIBS += -L$$OUT_PWD/../DTK/Widget/debug/ -ldwidget
else:unix: LIBS += -L$$OUT_PWD/../DTK/Widget/ -ldwidget

INCLUDEPATH += $$PWD/../DTK/Widget
DEPENDPATH += $$PWD/../DTK/Widget

win32-g++:CONFIG(release, debug|release): PRE_TARGETDEPS += $$OUT_PWD/../DTK/Widget/release/libdwidget.a
else:win32-g++:CONFIG(debug, debug|release): PRE_TARGETDEPS += $$OUT_PWD/../DTK/Widget/debug/libdwidget.a
else:win32:!win32-g++:CONFIG(release, debug|release): PRE_TARGETDEPS += $$OUT_PWD/../DTK/Widget/release/dwidget.lib
else:win32:!win32-g++:CONFIG(debug, debug|release): PRE_TARGETDEPS += $$OUT_PWD/../DTK/Widget/debug/dwidget.lib
else:unix: PRE_TARGETDEPS += $$OUT_PWD/../DTK/Widget/libdwidget.a

