#pragma once

#include "DWindow.h"

#include "../CloudPrintClient.h"

class ConfigData;

namespace ConfigDialogInnter {
    class Worker : public QObject {
        Q_OBJECT
    public:
        enum VerfiyResult{
            Success,
            InvaildAddress,
            InvaildAuthcode,
            InvaildPrinterList,
        };

        QString                         ipaddr;
        QString                         authcode;
        cloudprint::Auth                *auth;
        CloudPrintRPCClient             *client;
        std::vector<Printer> printers;

    public slots:
        void doListPrinter();

    signals:
        void finished();
        void listPrinterFinish(int errcode);

    private:
        std::vector<Printer> listPrinter();
    };
}

class ConfigDialog : public DWindow
{
    Q_OBJECT
public:


    explicit ConfigDialog(QWidget *parent = 0);
    void updateAuthcode(const QString& addr);
    QString getAuthcode();
    bool eventFilter(QObject *obj, QEvent *event);

signals:
    void closed();
    void verfiyStart();
    void verfiyFinish(bool);

public slots:
    void startVerfiy();
    void finishVerfiy(int errcode);
    void clearHits();
    void refreshPrinterList(int code);
    void manualClose(int);

private:

    QWidget *createAuthWidget();
    QWidget *createPrinterList();

    ConfigData * data;
};

class QProcess;

extern QProcess *g_DMan;
