#pragma once

#include <QWidget>


#include "../CloudPrintClient.h"

class DImageButton;
class DSpinner;
class DLabel;
class QLabel;

namespace PrinterWidgetInnter {

class Worker : public QObject {
    Q_OBJECT
public:
    enum VerfiyResult{
        Success,
        Failed,
    };
    cloudprint::Printer printer;

public slots:
    void doAddPrinter();

signals:
    void finished();
    void addPrinterFinish(int errcode);
};

}

class PrinterWidget : public QWidget
{
    Q_OBJECT
public:


    explicit PrinterWidget(Printer& p, bool added = false, QWidget *parent = 0);

    virtual void paintEvent(QPaintEvent *);

signals:
    void addPrinterBegin();
    void addPrinterFinish();

protected slots:
    void addPrinter();
    void finishAddPrinter(int errcode);
    void configPrinter();
    void checkStatus();

private:
    PrinterWidgetInnter::Worker     *worker;
    QLabel              *btIcon;
    DLabel              *printerAdded;
    DImageButton        *addBt;
    DSpinner            *addSpipper;
    Printer             printer;
    bool                exist;
};


