#pragma once

#include <QFile>
#include <QDebug>
#include <QColor>

namespace DUI {
    const QColor BorderColor = QColor(216, 216, 216);
    const QColor ShadowColor = QColor(23, 23, 23, 128);
    const QColor BackgroundTopColor = QColor(250, 251, 252);
    const QColor BackgroundBottonColor = QColor(250, 251, 252);
    const QColor TipsBorderColor = QColor(255, 255, 255, 255*0.2);
    const QColor TipsBackground = QColor(0, 0, 0);
}

extern QString g_ThemeName;

#define DUI_SET_THEME(themeNmae) \
    g_ThemeName = #themeNmae;

#define DUI_INIT_STYLESHEET(className) \
    QFile _file(QString(":/StyleSheet/%1/%2.qss").arg(g_ThemeName).arg(#className)); \
    /*qDebug()<<"Load"<<_file.fileName();*/ \
    _file.open(QFile::ReadOnly); \
    QString _styleSheet = QLatin1String(_file.readAll()); \
    setStyleSheet(_styleSheet);
