#ifndef DWINDOW_H
#define DWINDOW_H

#include <QWidget>

class QGraphicsDropShadowEffect;

class DWindow : public QWidget
{
    Q_OBJECT
public:
    explicit DWindow(QWidget *parent = 0);

    virtual void showEvent(QShowEvent *);
    virtual void paintEvent(QPaintEvent *);
    virtual void mousePressEvent(QMouseEvent *);
    virtual void mouseReleaseEvent(QMouseEvent *);
    virtual void mouseMoveEvent(QMouseEvent *);

    void setShadowHits(int glowRadius);

private:
    QGraphicsDropShadowEffect *m_Shadow;
    int     m_GlowRadius;
    int     m_Radius;
    QPoint  m_LastMousePos;
    bool    m_MousePressed;
};

#endif // DWINDOW_H
