#ifndef DBASEDIALOG_H
#define DBASEDIALOG_H

#include "DMovableDialog.h"

class QPushButton;
class QButtonGroup;
class QLabel;
class QCloseEvent;
class QVBoxLayout;

class DBaseDialog : public DMovabelDialog
{
    Q_OBJECT
public:
    explicit DBaseDialog(QWidget *parent = 0);
    ~DBaseDialog();

    void initUI(const QString& icon,
                QWidget *widget,
                const QStringList& buttonKeys,
                const QStringList& buttonTexts);

    void initConnect();

    QString getIcon();
    QStringList getButtons();
    QStringList getButtonTexts();
    QButtonGroup* getButtonsGroup();

signals:
    void aboutToClose();
    void closed();
    void buttonClicked(QString key);
    void buttonClicked(int index);

public slots:
   void setIcon(const QString& icon);
   void setButtons(const QStringList& buttons);
   void setButtonTexts(const QStringList& buttonTexts);
   void handleButtonsClicked(int id);
   void handleKeyEnter();

protected:
   void closeEvent(QCloseEvent* event);
   void resizeEvent(QResizeEvent* event);

protected:
   QPushButton* m_closeButton;

private:
    QString m_icon;
    QStringList m_buttonKeys;
    QStringList m_buttonTexts;
    int m_defaultWidth = 380;
    int m_defaultHeight = 160;

    QLabel* m_iconLabel;
    QButtonGroup* m_buttonGroup;

    int m_messageLabelMaxWidth;
};

#endif // DBASEDIALOG_H
