#include "DMessageBox.h"

#include <QLabel>
#include <QPushButton>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QDebug>

DMessageBox::DMessageBox(const QString& icon,
                         const QString& message,
                         const QString& tipMessage,
                         const QStringList& buttonKeys,
                         const QStringList& buttonTexts,
                         QWidget *parent) : DBaseDialog(parent)
{
    initUI(icon, message, tipMessage, buttonKeys, buttonTexts);
}


void DMessageBox::initUI(const QString& icon,
            const QString& message,
            const QString& tipMessage,
            const QStringList& buttonKeys,
            const QStringList& buttonTexts) {
    m_message = message;
    m_messageLabel = new QLabel(m_message);
    m_messageLabel->setObjectName("MessageLabel");
    m_messageLabel->setWordWrap(true);

    m_tipMessage = tipMessage;
    m_tipMessageLabel = new QLabel(m_tipMessage);
    m_tipMessageLabel->setObjectName("TipMessageLabel");
    m_tipMessageLabel->setWordWrap(true);

    m_messageLayout = new QVBoxLayout;
    m_messageLayout->addWidget(m_messageLabel);
    m_messageLayout->addWidget(m_tipMessageLabel);
    m_messageLayout->addStretch();
    m_messageLayout->setContentsMargins(5, m_closeButton->height(), m_closeButton->width(), 0);
    m_messageWidget = new QWidget;
    m_messageWidget->setLayout(m_messageLayout);

    DBaseDialog::initUI(icon, m_messageWidget, buttonKeys, buttonTexts);
}
