include "Print.thrift"

namespace cpp cloudprint

struct Auth {
  1: string Authcode,
  2: string Token,
  3: string Name,
  4: string ip
}

const i32 CloudPrintDefaultPort = 9100;

service CloudPrint {
    bool Verfiy(1: Auth auth) throws (1: Print.Exception err),

    Print.Printer DefaultPrinter(1: Auth auth) throws (1: Print.Exception err),
    list<Print.Printer> ListPrinter(1: Auth auth) throws (1: Print.Exception err),
    Print.Printer GetPrinter(1: Auth auth, 2: Print.PrinterID printer) throws (1:Print.Exception err),

    list<Print.Job> ListJobs(1: Auth auth, 2: Print.Printer printer) throws (1: Print.Exception err),
    Print.JobID CreateJob(1: Auth auth, 2: Print.Printer printer, 3: string title, 4: Print.Option options) throws (1: Print.Exception err),
    void WriteJob(1: Auth auth, 2: Print.Printer printer, 3: Print.JobID jobID, 4: i32 seq, 5: string data) throws (1: Print.Exception err),
    void FinishJob(1: Auth auth, 2: Print.Printer printer,  3: Print.JobID jobID) throws (1: Print.Exception err),
    void CancelJob(1: Auth auth, 2: Print.Printer printer, 3: Print.JobID jobId) throws (1: Print.Exception err),

    Print.Job GetJob(1: Auth auth, 2: Print.Printer printer, 3: Print.JobID jobId) throws (1: Print.Exception err),
    void SetJob(1: Auth auth, 2: Print.Printer printer, 3: Print.JobID JobId, 4: Print.JobCommand cmd) throws (1: Print.Exception err),
}
