include "Print.thrift"

namespace cpp cloudprint

const i32 PrinterAgentDefaultPort = 9002;

service PrinterAgent {
  Print.Printer DefaultPrinter() throws (1:Print.Exception err),
  list<Print.Printer> ListPrinter() throws (1:Print.Exception err),
  Print.Printer GetPrinter(1: Print.PrinterID printer) throws (1:Print.Exception err),

  list<Print.Job> ListJob(1: Print.PrinterID printer) throws (1:Print.Exception err),
  Print.JobID StartJob(1: Print.PrinterID printer, 2: string filePath, 3: Print.Option options) throws (1:Print.Exception err),
  Print.Job GetJob(1: Print.PrinterID printer, 2: Print.JobID jobID) throws (1:Print.Exception err),
  void ControlJob(1: Print.PrinterID printer, 2: Print.JobID jobID, 3: Print.JobCommand cmd) throws (1:Print.Exception err)
}

const i32 PrinterNotifyDefaultPort = 9003;

service PrinterNotify {
  void NotifyAddJob(1: Print.JobID jobID, 2: Print.Job job) throws (1:Print.Exception err),
  void NotifyChangeJob(1: Print.JobID jobID, 2: Print.Job job) throws (1:Print.Exception err),
  void NotifyDeleteJob(1: Print.JobID jobID, 2: Print.Job job) throws (1:Print.Exception err)
}
